searchNodes=[{"doc":"AppIdentity is an Elixir implementation of the Kinetic Commerce application identity proof algorithm . It implements identity proof generation and validation functions. These functions expect to work with an application structure ( AppIdentity.App.t/0 ). Telemetry Support If telemetry is a dependency in your application, and the telemetry is not explicitly disabled, telemetry events will be emitted for AppIdentity.generate_proof/2 , AppIdentity.verify_proof/3 , and AppIdentity.Plug . See AppIdentity.Telemetry for more information. Disabling Telemetry Telemetry may be disabled by setting this for your configuration: config :app_identity , AppIdentity.Telemetry , enabled : false Remember to run mix deps.compile --force tesla after changing this setting to ensure the change is picked up.","ref":"AppIdentity.html","title":"AppIdentity","type":"module"},{"doc":"Generate an identity proof string for the given application. Returns {:ok, proof} or :error . If nonce is provided, it must conform to the shape expected by the proof version. If not provided, it will be generated. If version is provided, it will be used to generate the nonce and the proof. This will allow a lower level application to raise its version level. Examples A version 1 app can have a fixed nonce, which will always produce the same value. iex&gt; { :ok , app } = AppIdentity.App . new ( %{ version : 1 , id : &quot;decaf&quot; , secret : &quot;bad&quot; } ) iex&gt; AppIdentity . generate_proof ( app , nonce : &quot;hello&quot; ) { :ok , &quot;ZGVjYWY6aGVsbG86RDNGNjJCQTYyOEIyMzhEOTgwM0MyNEU4NkNCOTY3M0ZEOTVCNTdBNkJGOTRFMkQ2NTMxQTRBODg1OTlCMzgzNQ==&quot; } A version 2 app fails when given a non-timestamp nonce. iex&gt; AppIdentity . generate_proof ( v1 ( ) , version : 2 , nonce : &quot;hello&quot; ) :error A version 2 app cannot generate a version 1 nonce. iex&gt; AppIdentity . generate_proof ( v2 ( ) , version : 1 ) :error A version 2 app will be rejected if the version has been disallowed. iex&gt; AppIdentity . generate_proof ( v2 ( ) , disallowed : [ 1 , 2 ] ) :error Telemetry When telemetry is enabled, generate_proof/2 will emit: [:app_identity, :generate_proof, :start] [:app_identity, :generate_proof, :stop]","ref":"AppIdentity.html#generate_proof/2","title":"AppIdentity.generate_proof/2","type":"function"},{"doc":"Generate an identity proof string for the given application. Returns the proof string or raises an exception on error. If nonce is provided, it must conform to the shape expected by the proof version. If not provided, it will be generated. If version is provided, it will be used to generate the nonce and the proof. This will allow a lower level application to raise its version level. Examples A version 1 app can have a fixed nonce, which will always produce the same value. iex&gt; { :ok , app } = AppIdentity.App . new ( %{ version : 1 , id : &quot;decaf&quot; , secret : &quot;bad&quot; } ) iex&gt; AppIdentity . generate_proof! ( app , nonce : &quot;hello&quot; ) &quot;ZGVjYWY6aGVsbG86RDNGNjJCQTYyOEIyMzhEOTgwM0MyNEU4NkNCOTY3M0ZEOTVCNTdBNkJGOTRFMkQ2NTMxQTRBODg1OTlCMzgzNQ==&quot; A version 2 app fails when given a non-timestamp nonce. iex&gt; AppIdentity . generate_proof! ( v1 ( ) , version : 2 , nonce : &quot;hello&quot; ) ** (AppIdentity.AppIdentityError) Error generating proof A version 2 app cannot generate a version 1 nonce. iex&gt; AppIdentity . generate_proof! ( v2 ( ) , version : 1 ) ** (AppIdentity.AppIdentityError) Error generating proof A version 2 app will be rejected if the version has been disallowed. iex&gt; AppIdentity . generate_proof! ( v2 ( ) , disallowed : [ 1 , 2 ] ) ** (AppIdentity.AppIdentityError) Error generating proof Telemetry When telemetry is enabled, generate_proof!/2 will emit: [:app_identity, :generate_proof, :start] - [:app_identity, :generate_proof, :stop]` Telemetry events are emitted before any error exceptions are thrown.","ref":"AppIdentity.html#generate_proof!/2","title":"AppIdentity.generate_proof!/2","type":"function"},{"doc":"The name, version, and supported specification version of this App Identity package for Elixir.","ref":"AppIdentity.html#info/0","title":"AppIdentity.info/0","type":"function"},{"doc":"The name, version, or supported specification version of this App Identity package for Elixir.","ref":"AppIdentity.html#info/1","title":"AppIdentity.info/1","type":"function"},{"doc":"Parses a proof string into an AppIdentity.Proof struct. Returns {:ok, proof} or :error .","ref":"AppIdentity.html#parse_proof/1","title":"AppIdentity.parse_proof/1","type":"function"},{"doc":"Parses a proof string into an AppIdentity.Proof struct. Returns the parsed proof or raises an exception.","ref":"AppIdentity.html#parse_proof!/1","title":"AppIdentity.parse_proof!/1","type":"function"},{"doc":"Verify a AppIdentity proof value using a a provided app . Returns {:ok, app} , {:ok, nil} , or :error . The proof may be provided either as a string or a parsed AppIdentity.Proof.t/0 (from parse_proof/1 ). String proof values are usually obtained from HTTP headers. At Kinetic Commerce, this has generally jeen KCS-Application or KCS-Service . The app can be provided as one of AppIdentity.App.input/0 , AppIdentity.App.t/0 , or AppIdentity.App.finder/0 . If provided a finder, it will be called with the proof value. verify_proof/3 has three possible return values: {:ok, AppIdentity.App} when the proof is validated against the provided or located application; {:ok, nil} when the proof matches the provided or located application, but it does not validate. :error when there is any error during proof validation. AppIdentity . verify_proof ( proof , &amp; IdentityApplications . get! ( &amp;1 . id ) ) Telemetry When telemetry is enabled, verif_proof/3 will emit: [:app_identity, :verify_proof, :start] [:app_identity, :verify_proof, :stop]","ref":"AppIdentity.html#verify_proof/3","title":"AppIdentity.verify_proof/3","type":"function"},{"doc":"Verify a AppIdentity proof value using a a provided app . Returns the app, nil, or raises an exception on error. The proof may be provided either as a string or a parsed AppIdentity.Proof.t/0 (from parse_proof/1 ). String proof values are usually obtained from HTTP headers. At Kinetic Commerce, this has generally jeen KCS-Application or KCS-Service . The app can be provided as one of AppIdentity.App.input/0 , AppIdentity.App.t/0 , or AppIdentity.App.finder/0 . If provided a finder, it will be called with the proof value. verify_proof/3 has two possible return values: AppIdentity.App when the proof is validated against the provided or located application; nil when the proof matches the provided or located application, but it does not validate. It raises an exception on any error during proof validation. AppIdentity . verify_proof ( proof , &amp; IdentityApplications . get! ( &amp;1 . id ) ) Telemetry When telemetry is enabled, verify_proof!/3 will emit: [:app_identity, :verify_proof, :start] [:app_identity, :verify_proof, :stop] Telemetry events are emitted before any error exceptions are thrown.","ref":"AppIdentity.html#verify_proof!/3","title":"AppIdentity.verify_proof!/3","type":"function"},{"doc":"A list of algorithm versions that are not allowed. The presence of an app in this list will prevent the generation or verification of proofs for the specified version. If nil , an empty list, or missing, all versions are allowed.","ref":"AppIdentity.html#t:disallowed/0","title":"AppIdentity.disallowed/0","type":"type"},{"doc":"The App Identity app unique identifier. Validation of the id value will convert non-string IDs using Kernel.to_string/1. If using integer IDs, it is recommended that the id value be provided as some form of extended string value, such as that provided by Rails global ID or the absinthe_relay Node.IDTranslator . Such representations are also recommended if the ID is a compound value. id/0 values must not contain a colon ( : ) character.","ref":"AppIdentity.html#t:id/0","title":"AppIdentity.id/0","type":"type"},{"doc":"A nonce value used in the algorithm proof. The shape of the nonce depends on the algorithm version/0 . Version 1 nonce/0 values should be cryptographically secure and non-sequential, but sufficiently fine-grained timestamps (those including microseconds, as yyyymmddHHMMSS.sss ) may be used. Version 1 proofs verify that the nonce is at least one byte long and do not contain a colon ( : ). Version 2, 3, and 4 nonce/0 values only permit fine-grained timestamps that should be generated from a clock in sync with Network Time Protocol servers. The timestamp will be parsed and compared to the server time (also in sync with an NTP server).","ref":"AppIdentity.html#t:nonce/0","title":"AppIdentity.nonce/0","type":"type"},{"doc":"Options for generating or verifying proofs. nonce can specify a precomputed nonce for proof generation. It will be verified by the algorithm version for correctness and compatibility, but will otherwise be used unmodified. This option is ignored for proof verification. version can specify the generation of a proof compatible with, but different than, the application version. This option is ignored for proof verification.","ref":"AppIdentity.html#t:option/0","title":"AppIdentity.option/0","type":"type"},{"doc":"The App Identity app secret value. This value is used as provided with no encoding or decoding. Because this is a sensitive value, it may be provided as a closure in line with the EEF Security Working Group sensitive data recommendation . AppIdentity.App always stores this value as a closure.","ref":"AppIdentity.html#t:secret/0","title":"AppIdentity.secret/0","type":"type"},{"doc":"The positive integer version of the App Identity algorithm to use. Will be validated to be a supported version for app creation, and not an explicitly disallowed version during proof validation. If provided as a string value, it must convert cleanly to an integer value, which means that a version of &quot;3.5&quot; is not a valid value. App Identity algorithm versions are strictly upgradeable. That is, a version 1 app can verify version 1, 2, 3, or 4 proofs. However, a version 2 app will never validate a version 1 proof. Version Nonce Digest Algorithm Can Verify 1 2 3 4 1 random SHA 256 ✅ ✅ ✅ ✅ 2 timestamp ± fuzz SHA 256 ⛔️ ✅ ✅ ✅ 3 timestamp ± fuzz SHA 384 ⛔️ ⛔️ ✅ ✅ 4 timestamp ± fuzz SHA 512 ⛔️ ⛔️ ⛔️ ✅","ref":"AppIdentity.html#t:version/0","title":"AppIdentity.version/0","type":"type"},{"doc":"The structure used by the App Identity proof generation and verification algorithms. This should be constructed from a provided map or struct, such as a static configuration file or a database record. The original structure or map is stored in the source attribute.","ref":"AppIdentity.App.html","title":"AppIdentity.App","type":"module"},{"doc":"Converts the provided input/0 value into an App struct ( t/0 ). May be provided a loader/0 function that will return an input/0 value for validation and conversion. If provided an App struct ( t/0 ), returns the provided app struct without validation. The result is {:ok, app} or {:error, reason} . Examples iex&gt; App . new ( %{ } ) { :error , &quot;id must not be nil&quot; } = App . new ( %{ id : nil } ) iex&gt; { :ok , app } = App . new ( %{ id : 1 , secret : &quot;secret&quot; , version : 1 } ) iex&gt; app . source %{ id : 1 , secret : &quot;secret&quot; , version : 1 } iex&gt; app . secret . ( ) &quot;secret&quot; iex&gt; { :ok , app } = App . new ( %{ id : 1 , secret : &quot;secret&quot; , version : 1 } ) iex&gt; { :ok , app_copy } = App . new ( app ) iex&gt; app == app_copy true","ref":"AppIdentity.App.html#new/1","title":"AppIdentity.App.new/1","type":"function"},{"doc":"An optional configuration value for validation of an AppIdentity proof. If not provided, the default value when required is {fuzz: 600} , specifying that the timestamp may not differ from the current time by more than ±600 seconds (±10 minutes). Depending on the nature of the app being verified and the expected network conditions, a shorter time period than 600 seconds is recommended. The AppIdentity version 1 algorithm does not use config .","ref":"AppIdentity.App.html#t:config/0","title":"AppIdentity.App.config/0","type":"type"},{"doc":"A finder function accepting a Proof struct parameter that returns a map or struct that can be converted into an App struct.","ref":"AppIdentity.App.html#t:finder/0","title":"AppIdentity.App.finder/0","type":"type"},{"doc":"A map or struct that can be converted into an App struct. If the map uses string keys, they are required to match the same definitions.","ref":"AppIdentity.App.html#t:input/0","title":"AppIdentity.App.input/0","type":"type"},{"doc":"","ref":"AppIdentity.App.html#t:invalid_input/0","title":"AppIdentity.App.invalid_input/0","type":"type"},{"doc":"A 0-arity loader function that returns a map or struct that can be converted into an App struct.","ref":"AppIdentity.App.html#t:loader/0","title":"AppIdentity.App.loader/0","type":"type"},{"doc":"A representation of an AppIdentity app used for proof generation and verification. The input/0 value used in the construction of the App is stored in source . The verified flag value indicates whether the app was used in the successful verification of a proof.","ref":"AppIdentity.App.html#t:t/0","title":"AppIdentity.App.t/0","type":"type"},{"doc":"A Plug that verifies App Identity proofs provided via one or more HTTP headers. When multiple proof values are provided in the request, all must be successfully verified. If any of the proof values cannot be verified, request processing halts with 403 Forbidden . Should no proof headers are included, the request is considered invalid. All of the above behaviours can be modified through configuration . The results of completed proof validations can be found at %Plug.Conn{private: %{app_identity: %{}}} , regardless of the success or failure state. Telemetry When telemetry is enabled, this plug will emit [:app_identity, :plug, :start] and [:app_identity, :plug, :stop] events.","ref":"AppIdentity.Plug.html","title":"AppIdentity.Plug","type":"module"},{"doc":"","ref":"AppIdentity.Plug.html#t:on_failure/0","title":"AppIdentity.Plug.on_failure/0","type":"type"},{"doc":"","ref":"AppIdentity.Plug.html#t:on_failure_fn/0","title":"AppIdentity.Plug.on_failure_fn/0","type":"type"},{"doc":"AppIdentity.Plug configuration options prior to validation. apps : A list of AppIdentity.App or AppIdentity.App.input/0 values to be used for proof validation. Duplicate values will be ignored. disallowed : A list of algorithm versions that are not allowed when processing received identity proofs. See AppIdentity.disallowed/0 . finder : An AppIdentity.App.finder/0 function to load an AppIdentity.App.input/0 from an external source given a parsed proof. headers : A list of HTTP header names. on_failure : The behaviour of the AppIdentity.Plug when proof validation fails. Must be one of the following values: :forbidden : Halt request processing and respond with a 403 (forbidden) status. This is the same as {:halt, :forbidden} . This is the default on_failure behaviour. {:halt, Plug.Conn.status()} : Halt request processing and return the specified status code. An empty body is emitted. {:halt, Plug.Conn.status(), Plug.Conn.body()} : Halt request processing and return the specified status code. The body value is included in the response. :continue : Continue processing, ensuring that failure states are recorded for the application to act on at a later point. This could be used to implement a distinction between validating a proof and requiring that the proof is valid. A 1-arity anonymous function or a {module, function} tuple accepting Plug.Conn that returns one of the above values. At least one of apps or finder must be supplied. If both are present, apps are looked up in the apps list first. plug AppIdentity.Plug , header : &quot;application-identity&quot; , finder : fn proof -&gt; ApplicationModel . get! ( proof . id ) end","ref":"AppIdentity.Plug.html#t:option/0","title":"AppIdentity.Plug.option/0","type":"type"},{"doc":"Normalized options for AppIdentity.Plug.","ref":"AppIdentity.Plug.html#t:t/0","title":"AppIdentity.Plug.t/0","type":"type"},{"doc":"A structure describing a computed or parsed App Identity proof.","ref":"AppIdentity.Proof.html","title":"AppIdentity.Proof","type":"module"},{"doc":"Build an AppIdentity.Proof struct from an AppIdentity.App struct and a nonce. This method returns the either {:ok, proof} or {:error, reason} Examples: iex&gt; AppIdentity.Proof . build ( ...&gt; AppIdentity.App . new! ( %{ ...&gt; id : &quot;867-5309&quot; , ...&gt; secret : &quot;Something unguessable&quot; , ...&gt; version : 1 ...&gt; } ) , ...&gt; &quot;a nonce&quot; ...&gt; ) { :ok , % AppIdentity.Proof { id : &quot;867-5309&quot; , nonce : &quot;a nonce&quot; , version : 1 , padlock : &quot;57384B64BF69703296DF9E4C93DC83CF4B96EAF20298006897DFBC2A63904219&quot; } } iex&gt; AppIdentity.Proof . build ( ...&gt; AppIdentity.App . new! ( %{ ...&gt; id : &quot;123-456-789&quot; , ...&gt; secret : fn -&gt; &quot;Something unguessable&quot; end , ...&gt; version : 2 ...&gt; } ) , ...&gt; &quot;&quot; , ...&gt; version : 3 ...&gt; ) { :error , &quot;nonce must not be an empty string&quot; }","ref":"AppIdentity.Proof.html#build/3","title":"AppIdentity.Proof.build/3","type":"function"},{"doc":"","ref":"AppIdentity.Proof.html#from_string/1","title":"AppIdentity.Proof.from_string/1","type":"function"},{"doc":"","ref":"AppIdentity.Proof.html#to_string/1","title":"AppIdentity.Proof.to_string/1","type":"function"},{"doc":"","ref":"AppIdentity.Proof.html#verify/3","title":"AppIdentity.Proof.verify/3","type":"function"},{"doc":"The components of a parsed AppIdentity proof.","ref":"AppIdentity.Proof.html#t:t/0","title":"AppIdentity.Proof.t/0","type":"type"},{"doc":"If telemetry is a dependency in your application, and the telemetry is not explicitly disabled, telemetry events will be emitted for AppIdentity.generate_proof/2 , AppIdentity.verify_proof/3 , and AppIdentity.Plug . See AppIdentity.Telemetry for more information. Telemetry Events All of AppIdentity 's telemetry events are spans, consisting of :start and :stop events. These are always in the form [:app_identity, &lt;telemetry_type&gt;, &lt;event&gt;] . The events are: [:app_identity, :generate_proof, :start] emitted when AppIdentity.generate_proof/2 or AppIdentity.generate_proof!/2 is called. [:app_identity, :generate_proof, :stop] emitted when AppIdentity.generate_proof/2 or AppIdentity.generate_proof!/2 finishes, either on success or failure. Telemetry is generated prior to the raising of any exceptions for AppIdentity.generate_proof/2 . [:app_identity, :plug, :start] emitted when AppIdentity.Plug is called. If AppIdentity.Plug is called in-line, exceptions may be thrown if there are configuration issues and telemetry will not be emitted. [:app_identity, :plug, :stop] emitted when the response is sent after AppIdentity.Plug completes. [:app_identity, :verify_proof, :start] emitted when AppIdentity.verify_proof/3 or AppIdentity.verify_proof!/3 is called. [:app_identity, :verify_proof, :stop] emitted when AppIdentity.verify_proof/3 or AppIdentity.verify_proof!/3 finishes, either on success or failure. Telemetry is verified prior to the raising of any exceptions for AppIdentity.verify_proof/3 . Measurements All AppIdentity telemetry events measure one of two things: :start events always measure monotonic_time ( :erlang.monotonic_time/0 ) and system_time ( :erlang.system_time/0 ). :stop events always measure monotonic_time ( :erlang.monotonic_time/0 ) and duration (the difference between the start time and stop time). Metadata All AppIdentity telemetry includes a telemetry_span_context key which is a :erlang.reference/0 . In this version, this value will be generated with the :start event and reused for the :stop event. When a measurement type is given as t:telemetry_app , this will be one of the following values: [:app_identity, :generate_proof, :start] Metadata app : telemetry_app/0 options : a list of AppIdentity.option/0 [:app_identity, :generate_proof, :stop] Metadata app : telemetry_app/0 options : a list of AppIdentity.option/0 One of: proof : The generated proof string error : A descriptive error [:app_identity, :plug, :start] Metadata conn : Plug.Conn.t/0 options : A map with the following keys (derived from AppIdentity.Plug.option/0 ): apps : a list of telemetry_app/0 finder : Either a value of AppIdentity.Plug.on_failure/0 or the string &quot;function&quot; if the on_failure value is AppIdentity.Plug.on_failure_fn/0 . [:app_identity, :plug, :stop] Metadata conn : Plug.Conn.t/0 , updated after processing options : A map with the following keys (derived from AppIdentity.Plug.option/0 ): apps : a list of telemetry_app/0 finder : Either a value of AppIdentity.Plug.on_failure/0 or the string &quot;function&quot; if the on_failure value is AppIdentity.Plug.on_failure_fn/0 . [:app_identity, :verify_proof, :start] Metadata app : telemetry_app/0 options : a list of AppIdentity.option/0 One of: candidate : The candidate proof string proof : The parsed proof [:app_identity, :verify_proof, :stop] Metadata app : telemetry_app/0 . In the case of an error, this will be the same app value as was reported in the :start event. If not, this value will be the post-verification version of the app . options : a list of AppIdentity.option/0 One of: candidate : The candidate proof string proof : The parsed proof In case of an error: error : A descriptive error Disabling Telemetry Telemetry may be disabled by setting this for your configuration: config :app_identity , AppIdentity.Telemetry , enabled : false Remember to run mix deps.compile --force app_identity after changing this setting to ensure the change is picked up.","ref":"AppIdentity.Telemetry.html","title":"AppIdentity.Telemetry","type":"module"},{"doc":"A telemetry-safe version of an input or verified app. May be one of the following values: nil : the app is not found or does not verify correctly. &quot;loader&quot; : the app provided is a AppIdentity.App.loader/0 function. &quot;finder&quot; : the app provided is a AppIdentity.App.finder/0 function. Otherwise, a map is returned with required :id and :version keys and optional :config and :verified keys.","ref":"AppIdentity.Telemetry.html#t:telemetry_app/0","title":"AppIdentity.Telemetry.telemetry_app/0","type":"opaque"},{"doc":"A Tesla middleware that generates an app identity proof header for a request. The options provided has the following parameters: app : (required) A value that can be passed to AppIdentity.App.new/1. disallowed : A list of algorithm versions that are not allowed when processing received identity proofs. See AppIdentity.disallowed/0 . header : (required) The header to use for sending the app identity proof. on_failure : (optional) The action to take when an app identity proof cannot be generated for any reason except configuration errors. May be one of the following values: :fail : Fails the request with an error tuple. This is the default if on_failure is not specified. :pass : Sets the header to the empty value returned. The request will probably fail on the receiving server side. :skip : Does not add the header, as if the request were not made using an application. on_failure may also be provided an arity 3 function or {module, function} tuple that expects three parameters: env : The Tesla middleware env value; app : The identity app value provided to the middleware; and header : The header name provided to the middleware. The function may return either the env , :fail , :skip , or :pass . Any other value will be treated as :fail .","ref":"AppIdentity.TeslaMiddleware.html","title":"AppIdentity.TeslaMiddleware","type":"module"},{"doc":"","ref":"AppIdentity.TeslaMiddleware.html#t:on_failure/0","title":"AppIdentity.TeslaMiddleware.on_failure/0","type":"type"},{"doc":"","ref":"AppIdentity.TeslaMiddleware.html#t:on_failure_fn/0","title":"AppIdentity.TeslaMiddleware.on_failure_fn/0","type":"type"},{"doc":"","ref":"AppIdentity.TeslaMiddleware.html#t:option/0","title":"AppIdentity.TeslaMiddleware.option/0","type":"type"},{"doc":"Generate or run an app identity test suite Usage mix app_identity [ options ] [ command ] Options - V , -- version Display the version number - h , -- help Display help Commands generate Generates an integration test suite run Runs one or more integration suites help Display help for command","ref":"Mix.Tasks.AppIdentity.html","title":"Mix.Tasks.AppIdentity","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.AppIdentity.html#run/1","title":"Mix.Tasks.AppIdentity.run/1","type":"function"},{"doc":"An exception that will be raised by AppIdentity.generate_proof!/2 , AppIdentity.parse_proof!/1 , or AppIdentity.verify_proof!/3 when those functions fail. The error message reported here is always generic. This can also be raised by AppIdentity.Plug on configuration failure.","ref":"AppIdentity.AppIdentityError.html","title":"AppIdentity.AppIdentityError","type":"exception"},{"doc":"code :: https://github.com/KineticCafe/app-identity/tree/main/elixir issues :: https://github.com/KineticCafe/app-identity/issues","ref":"readme.html","title":"AppIdentity for Elixir","type":"extras"},{"doc":"AppIdentity is an Elixir implementation of the Kinetic Commerce application identity proof algorithm as described in its spec .","ref":"readme.html#description","title":"AppIdentity for Elixir - Description","type":"extras"},{"doc":"app = %{ id : id , secret : secret , version : 2 } proof = AppIdentity . generate_proof ( app ) AppIdentity . verify_proof ( proof , app ) There is a Plug available for authenticating applications, AppIdentity.Plug . plug AppIdentity.Plug , headers : [ &quot;app-identity-proof&quot; ] , finder : fn %{ id : id } = _proof -&gt; IdentityApplications . get ( id ) end There is a Tesla Middleware for providing proof generation for clients. def client ( app ) do middleware = [ { AppIdentity.TeslaMiddleware , identity_app : app , header : &quot;app-identity-proof&quot; } ] end","ref":"readme.html#synopsis","title":"AppIdentity for Elixir - Synopsis","type":"extras"},{"doc":"The package can be installed by adding app_identity to your list of dependencies in mix.exs : def deps do [ { :app_identity , &quot;~&gt; 1.0&quot; } ] end If you need to use a pre-release version, the dependency structure is slightly different: def deps do [ { :app_identity , github : &quot;KineticCafe/app_identity&quot; , sparse : &quot;elixir&quot; } ] end If on Elixir 1.13 or later, you can use :subdir instead: def deps do [ { :app_identity , github : &quot;KineticCafe/app_identity&quot; , subdir : &quot;elixir&quot; } ] end Optional features are present when Plug and/or Tesla are part of your application. Documentation can found at HexDocs or generated with ex_doc .","ref":"readme.html#installation","title":"AppIdentity for Elixir - Installation","type":"extras"},{"doc":"AppIdentity uses a Semantic Versioning scheme with one significant change: When PATCH is zero ( 0 ), it will be omitted from version references. Additionally, the major version will generally be reserved for specification revisions.","ref":"readme.html#semantic-versioning","title":"AppIdentity for Elixir - Semantic Versioning","type":"extras"},{"doc":"AppIdentity for Elixir welcomes contributions . This project, like all Kinetic Commerce open source projects , is under the Kinetic Commerce Open Source Code of Conduct . AppIdentity for Elixir is licensed under the Apache Licence, version 2.0 and requires certification of a Developer Certificate of Origin. See Licence.md for more details.","ref":"readme.html#contributing","title":"AppIdentity for Elixir - Contributing","type":"extras"},{"doc":"We value contributions to AppIdentity for Elixir—bug reports, discussions, feature requests, and code contributions. New features should be proposed and discussed prior to implementation, and release of any new feature may be delayed until implemented in the three reference implementations. Before contributing patches, please read the Licence.md . App Identity is governed under the Kinetic Commerce Open Source Code of Conduct .","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Our usual code contribution guidelines apply: Code changes will not be accepted without tests. We use mix format and Credo for consistent coding style and formatting. Use a thoughtfully-named topic branch that contains your change. Rebase your commits into logical chunks as necessary. Use quality commit messages . The version number must not be changed except as part of the release process. Submit a pull request with your changes. New or changed behaviours require new or updated documentation. New dependencies are discouraged, unless they are optional (as we have done for Plug and Tesla). There are code quality checks performed in GitHub Actions that must pass for any pull request to be accepted.","ref":"contributing.html#code-guidelines","title":"Contributing - Code Guidelines","type":"extras"},{"doc":"","ref":"Changelog.md.html","title":"Changelog","type":"extras"},{"doc":"Add optional Telemetry support. If :telemetry is in your application's dependencies, and Telemetry support is not explicitly disabled, events will be emitted for AppIdentity.generate_proof/2 , AppIdentity.verify_proof/3 , and AppIdentity.Plug . Disable by adding this line to your application's configuration:' config :app_identity , AppIdentity.Telemetry , enabled : false Fixed various issues on Elixir 1.10.","ref":"Changelog.md.html#1-1-0-2023-03-28","title":"Changelog - 1.1.0 / 2023-03-28","type":"extras"},{"doc":"Initial release.","ref":"Changelog.md.html#1-0-0-2022-09-07","title":"Changelog - 1.0.0 / 2022-09-07","type":"extras"},{"doc":"App Identity provides a fast, lightweight, cryptographically secure app authentication mechanism as an improvement over just using API keys or app IDs. It does this by computing a proof with an application identifier, a nonce, an application secret key, and a hashing algorithm. The secret key is embedded in client applications and stored securely on the server, so it is never passed over the wire.","ref":"spec.html","title":"App Identity Specification","type":"extras"},{"doc":"The key words &quot;MUST&quot;, &quot;MUST NOT&quot;, &quot;REQUIRED&quot;, &quot;SHALL&quot;, &quot;SHALL NOT&quot;, &quot;SHOULD&quot;, &quot;SHOULD NOT&quot;, &quot;RECOMMENDED&quot;, &quot;MAY&quot;, and &quot;OPTIONAL&quot; in this document are to be interpreted as described in RFC2199 . Only the text of this specification is normative . Code examples in this document are informative and may have bugs.","ref":"spec.html#terminology-notes","title":"App Identity Specification - Terminology Notes","type":"extras"},{"doc":"This specification is versioned with a modified Semantic Versioning scheme. The major version of the specification will always be the highest algorithms version defined. Minor versions may adjust the text of the specification. As the current specification defines four algorithm versions, the current specification is 4.0 .","ref":"spec.html#version-and-versioning","title":"App Identity Specification - Version and Versioning","type":"extras"},{"doc":"For the purposes of this specification, an application requires the following attributes: id : The unique identifier of the application. It is recommended that this value is a UUID . When using an integer identifier, it is recommended that this value be extended, such as that provided by Rails global ID . Such representations are also recommended if the ID is a compound value. Non-string identifiers must be converted to string values. secret : The random value used as the secret key. This value must be used as presented (if presented as a base-64 value, the secret is the base-64 value, not a decoded version of it). version : The minimum algorithm version supported by the application, an integer value. The reference implementations of App Identity do not currently restrict the version for compatibility purposes, but new applications should not use version 1 applications. config : A configuration object. As of this writing, only one key for this object is defined when version 2 or higher. The config only affects proof verification. fuzz : The fuzziness of time stamp comparison, in seconds, for version 2 or higher algorithms. If not present, defaults to 600 seconds, or ±600 seconds (±10 minutes). Depending on the nature of the app being verified and the expected network conditions, a shorter time period than 600 seconds is recommended. Suggested Extra Fields The following fields are recommended for use on by proof verifiers. code : A unique text identifier for the application. Not used in the proof algorithm, but used to manage the application on the servers. name : A displayable name for the application. Not used in the proof algorithm, but used for human consumption. type : The type of the application. Because the server deals with many types of applications, this value may be used to limit access to APIs to only type of applications.","ref":"spec.html#application","title":"App Identity Specification - Application","type":"extras"},{"doc":"The algorithm version controls both the shape of the nonce and the specific algorithm chosen for hashing. Versions are strictly upgradeable . That is, a version 1 app can verify version 1, 2, 3, or 4 proofs. However, a version 2 app will never validate a version 1 proof. Version Nonce Digest Algorithm Can Verify 1 2 3 4 1 random SHA 256 ✅ ✅ ✅ ✅ 2 timestamp ± fuzz SHA 256 ⛔️ ✅ ✅ ✅ 3 timestamp ± fuzz SHA 384 ⛔️ ⛔️ ✅ ✅ 4 timestamp ± fuzz SHA 512 ⛔️ ⛔️ ⛔️ ✅","ref":"spec.html#algorithm-versions","title":"App Identity Specification - Algorithm Versions","type":"extras"},{"doc":"The client identity proof is a short signed value, composed from the id , a nonce , and an intermediary padlock generated using the application secret . The application id and secret will be provided securely for compile-time inclusion; all care should be taken to ensure that the secret is not easily extractable from the application or shared in the clear. The generation of a proof looks like this: padlock = Padlock ( Version , Identity , Nonce , Secret ) proof = Proof ( Version , Identity , Nonce , padlock ) The verification of a proof looks like this: ( Version , Identity , Nonce , padlock ) = Parse ( proof ) app = FindApplication ( Identity ) padlockʹ = Padlock ( Version , app . Identity , Nonce , app . Secret ) proofʹ = Proof ( Version , Identity , Nonce , padlockʹ ) ConstantTimeEqualityComparison ( proof , proofʹ ) Nonce Depending on the version of the application algorithm, the nonce may contain any byte sequences except ASCII colon ( : ), but it is recommended that the value be UTF-8 safe. Random Nonces Version 1 nonces should be cryptographically secure and non-sequential, but sufficiently fine-grained timestamps (those including microseconds, as yyyymmddHHMMSS.sss ) may be used. Version 1 proofs verify that the nonce is at least one byte long and do not contain a colon ( : ). Ruby : require 'securerandom' nonce1 = SecureRandom.urlsafe_base64(32) nonce2 = SecureRandom.hex(32) Elixir : # Elixir Base . url_encode64 ( :crypto . strong_rand_bytes ( 32 ) , padding : true ) Base . encode16 ( :crypto . strong_rand_bytes ( 32 ) ) Typescript (Node) : import { randomBytes } from 'crypto' import base64url from 'base64-url' // https://www.npmjs.com/package/base64-url base64url.encode(randomBytes(32).toString()) Swift : func secure_random_base64_bytes(count: Int32 = 16) -&gt; String? { var data = Data(count: count) let result = data.withUnsafeMutableBytes { SecRandomCopyBytes(kSecRandomDefaults, data.count, $0) } if result == errSecSuccess { return data.base64EncodedString() } else { return nil } } secure_random_base64_bytes(32) Timestamp Nonces Version 2, 3, and 4 nonces must be a UTC timestamp formatted using ISO 8601 basic formatting. The timestamp should be generated on a clock synced with NTP and should be verified using a clock synced with NTP. For the purposes of this document, ISO 8601 basic formatting uses the following ABNF format, adapted from RFC3339 : date-fullyear = 4DIGIT date-month = 2DIGIT ; 01-12 date-mday = 2DIGIT ; 01-28, 01-29, 01-30, 01-31 based on ; month/year time-hour = 2DIGIT ; 00-23 time-minute = 2DIGIT ; 00-59 time-second = 2DIGIT ; 00-58, 00-59, 00-60 based on leap second ; rules time-secfrac = &quot;.&quot; 1\\*DIGIT time-offset = &quot;Z&quot; partial-time = time-hour time-minute time-second [time-secfrac] full-date = date-fullyear date-month date-mday full-time = partial-time time-offset date-time = full-date &quot;T&quot; full-time The timestamp must be an ASCII 7-bit or UTF-8 string using only ASCII characters, and the special characters T and Z must be specified uppercase. This format differs from RFC3339 §5.6 timestamp format in the following ways: It must be UTC and the timezone character must be Z . No other timezone specifier is permitted, and it must not be omitted. It must only have the characters [.0-9TZ] . It may have the point character ( . ) only preceding the optional fractional seconds digits. Therefore, a timestamp of 2020-02-25T23:20:03.321423-04:00 must be presented as 20200225T192003.321423Z . C-style strftime formatting for this format would be '%Y%m%dT%H%M%S.%6NZ' , and a PostgreSQL format for TO_CHAR() would 'YYYYMMDD&quot;T&quot;HH24MISS.FF6Z' . Ruby : require 'time' Time.now.utc.strftime('%Y%m%dT%H%M%S.%6NZ') Elixir : case DateTime . now ( &quot;Etc/UTC&quot; ) do { :ok , stamp } -&gt; { :ok , DateTime . to_iso8601 ( stamp , :basic ) } { :error , reason } -&gt; { :error , String . replace ( Kernel . to_string ( reason ) , &quot;_&quot; , &quot; &quot; ) } end Typescript (Node) : new Date().toISOString().replace(/[-:]/g, '') Swift : func secure_random_base64_bytes(count: Int32 = 16) -&gt; String? { var data = Data(count: count) let result = data.withUnsafeMutableBytes { SecRandomCopyBytes(kSecRandomDefaults, data.count, $0) } if result == errSecSuccess { return data.base64EncodedString() } else { return nil } } secure_random_base64_bytes(32) Padlock Calculation To compute the padlock value, concatenate the application id, the nonce, and the application secret using colons, then calculate the digest of the value and convert to a base 16 string representation. As noted previously, the digest algorithm used varies based on the application version. Ruby : require 'digest/sha2' Digest::SHA256.hexdigest([version, id, nonce, secret].join(':')).upcase Elixir : [ id , nonce , secret ] |&gt; Enum . join ( &quot;:&quot; ) |&gt; then ( &amp; :crypto . hash ( :sha256 , &amp;1 ) ) |&gt; Base . encode16 ( case : :upper ) Typescript (Node) : import { createHash } from 'crypto' const hash = createHash('sha384') hash.update(raw, 'utf-8') hash.digest('hex').toUpperCase() Swift : // Swift extension Data { func hexString() -&gt; String { return self.map { Int($0).hexString() }.joined() } func SHA256() -&gt; Data { var result = Data(count: Int(CC_SHA256_DIGEST_LENGTH)) _ = result.withUnsafeMutableBytes { resultPtr in self.withUnsafeBytes { CC_SHA256($0, CC_LONG(count), resultPtr) } } return result } } extension String { func hexString() -&gt; String { return self.data(using: .utf8)!.hexString() } func SHA256() -&gt; String { return self.data(using: .utf8)!.SHA256().hexString() } } let value = &quot;\\(id):\\(nonce):\\(secret)&quot; let padlock = value.SHA256() Java : // Java (Android) String value = id + &quot;:&quot; + nonce + &quot;:&quot; + secret; MessageDigest digest = MessageDigest.getInstance(&quot;SHA-256&quot;); byte[] hash = digest.digest(msg.getBytes(StandardCharsets.UTF_8)); StringBuffer padlock = new StringBuffer(); for (int i = 0; i &lt; hash.length; i++) { String hex = Integer.toHexString(0xFF &amp; hash[i]); if (hex.length() == 1) { padlock.append('0'); } padlock.append(hex); } Validation of the padlock will convert this digest to uppercase, so the values c0ffee and C0FFEE are identical. It is recommended that padlocks be passed as uppercase hex values. Padlock Presentation The padlock cannot be presented by itself, because the digest used are one-way cryptographic hashes. Therefore, the client must supply the id (used to find the client definition on the server) and the nonce (because the nonce is generated by the client application and not known by the server). This will typically be provided as a concatenated, base-64-encoded string: Ruby : require 'base64' # Version 1 Base64.urlsafe_encode64([id, nonce, padlock].join(':')) # Version 2+ Base64.urlsafe_encode64([version, id, nonce, padlock].join(':')) Elixir : [ version , id , nonce , padlock ] |&gt; Enum . join ( &quot;:&quot; ) |&gt; Base . urlsafe_encode64 ( padding : false ) Swift : let value = &quot;\\(version):\\(id):\\(nonce):\\(padlock)&quot; let proof = Data(value.utf8).base64EncodedString() Typescript : import base64url from 'base64-url' // https://www.npmjs.com/package/base64-url const parts = version === 1 ? [id, nonce, padlock] : [version, id, nonce, padlock] base64url.encode(parts.join(':')) Java : String value = version + &quot;:&quot; + id + &quot;:&quot; + nonce + &quot;:&quot; + padlock.toString(); byte[] encodedHash = Base64.getEncoder().encode(encodeValue.getBytes()); String proof = new String(encodedHash, &quot;UTF-8&quot;);","ref":"spec.html#identity-proof","title":"App Identity Specification - Identity Proof","type":"extras"},{"doc":"App Identity for Elixir is copyright © 2022 Kinetic Commerce and contributors and is licensed under Apache Licence, version 2.0 .","ref":"Licence.md.html","title":"Licence","type":"extras"},{"doc":"All contributors must certify they are able and willing to provide their contributions under the terms of this project's licenses with the certification of the Developer Certificate of Origin (Version 1.1) . Such certification is provided by ensuring that the following line must be included as the last line of a commit message for every commit contributed: Signed - off - by : FirstName LastName &lt; email @example . org &gt; The Signed-off-by line can be automatically added by git with the -s or --signoff option on git commit : git commit --signoff","ref":"Licence.md.html#developer-certificate-of-origin","title":"Licence - Developer Certificate of Origin","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: - You must give any other recipients of the Work or Derivative Works a copy of this License; and - You must cause any modified files to carry prominent notices stating that You changed the files; and - You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and - If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"APACHE-2.0.txt.html","title":"Apache Licence, version 2.0","type":"extras"},{"doc":"Developer Certificate of Origin Version 1.1 Copyright (C) 2004, 2006 The Linux Foundation and its contributors. Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed. Developer's Certificate of Origin 1.1 By making a contribution to this project, I certify that: (a) The contribution was created in whole or in part by me and I have the right to submit it under the open source license indicated in the file; or (b) The contribution is based upon previous work that, to the best of my knowledge, is covered under an appropriate open source license and I have the right under that license to submit that work with modifications, whether created in whole or in part by me, under the same open source license (unless I am permitted to submit under a different license), as indicated in the file; or (c) The contribution was provided directly to me by some other person who certified (a), (b) or (c) and I have not modified it. (d) I understand and agree that this project and the contribution are public and that a record of the contribution (including all personal information I submit with it, including my sign-off) is maintained indefinitely and may be redistributed consistent with this project or the open source license(s) involved.","ref":"dco.txt.html","title":"Developer Certificate of Origin","type":"extras"}]